/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

#include <iostream>
#include <iomanip>
#include <Utility.H>

// this mersenne_ran_main() outputs first 1000 generated numbers
// compare against the output of mt19937int.out
int
main(int argc, char** argv)
{
  BoxLib::Initialize(argc,argv);
  BoxLib::mt19937 rr(4357UL);
    std::ios::fmtflags ofmtflags = std::cout.setf(std::ios::fixed, std::ios::floatfield);
    std::cout << std::setprecision(8);
    for ( int j=0; j<1000; j++ )
    {
	std::cout << std::setw(10) << rr.u_value() << ' ';
	if ( j%5==4 ) std::cout << std::endl;
    }
    std::cout << std::endl;
    BoxLib::Finalize();
}
