/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/


#ifndef _RegType_H_
#define _RegType_H_

enum RegType
{
    interior, exterior, periodic, refWall, inflow, outflow, REG_TYPE_SIZE
};

inline
RegType
RegTypeSet(const std::string& ass)
{
    if ( ass == "interior" ) return interior ;
    if ( ass == "exterior" ) return exterior ;
    if ( ass == "periodic" ) return periodic ;
    if ( ass == "refWall"  ) return refWall  ;
    if ( ass == "inflow"   ) return inflow   ;
    if ( ass == "outflow"  ) return outflow  ;
    return REG_TYPE_SIZE;
}


#endif /*_RegType_H_*/
