/*
** (c) 1996-2000 The Regents of the University of California (through
** E.O. Lawrence Berkeley National Laboratory), subject to approval by
** the U.S. Department of Energy.  Your use of this software is under
** license -- the license agreement is attached and included in the
** directory as license.txt or you may contact Berkeley Lab's Technology
** Transfer Department at TTD@lbl.gov.  NOTICE OF U.S. GOVERNMENT RIGHTS.
** The Software was developed under funding from the U.S. Government
** which consequently retains certain rights as follows: the
** U.S. Government has been granted for itself and others acting on its
** behalf a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, and perform publicly
** and display publicly.  Beginning five (5) years after the date
** permission to assert copyright is obtained from the U.S. Department of
** Energy, and subject to any subsequent five (5) year renewals, the
** U.S. Government is granted for itself and others acting on its behalf
** a paid-up, nonexclusive, irrevocable, worldwide license in the
** Software to reproduce, prepare derivative works, distribute copies to
** the public, perform publicly and display publicly, and to permit
** others to do so.
*/

//
// XYPlotDefaults.H -- Default values for XY Plotter
//

#ifndef _XYPLOTDEFAULTS_H
#define _XYPLOTDEFAULTS_H

#define DEF_MARK_FLAG		"off"
#define DEF_LARGEMARK_FLAG	"off"
#define DEF_STYLEMARK_FLAG      "off"
#define DEF_TICK_FLAG		"off"
#define DEF_TICKAXIS_FLAG	"off"
#define DEF_BB_FLAG		"off"
#define DEF_PLOTLINE_FLAG	"on"
#define DEF_DISPHINTS_FLAG      "on"

#define DEF_LINE_WIDTH		"0"
#define DEF_GRID_WIDTH		"0"
#define DEF_DOT_WIDTH           "8"

#define DEF_XUNIT_TEXT_X     "X"
#define DEF_XUNIT_TEXT_Y     "Y"
#define DEF_XUNIT_TEXT_Z     "Z"

#define DEF_YUNIT_TEXT		"Val"
#define DEF_FMT_X		"%.2f"
#define DEF_FMT_Y		"%.2f"

#define DEF_GRID_STYLE		"10"
#define DEF_LABEL_FONT		"helvetica-10"
#define DEF_TITLE_FONT		"helvetica-18"

#define DEF_INIT_WIN_WIDTH      "250"
#define DEF_INIT_WIN_HEIGHT     "275"
#define DEF_INIT_WIN_OFFSET_X   "0"
#define DEF_INIT_WIN_OFFSET_Y   "450"

// Black and white defaults
#define DEF_BW_BACKGROUND	"white"
#define DEF_BW_BORDER		"black"
#define DEF_BW_FOREGROUND	"black"

// Color defaults
#define DEF_COL_BACKGROUND	"#ccc"
#define DEF_COL_BORDER		"black"
#define DEF_COL_FOREGROUND	"black"
#define DEF_COL_FIRSTSTYLE	"1"
#define DEF_GRID_COLOR          "gray"
#define DEF_TEXT_COLOR          "white"

#define DEF_INT		"0"
#define DEF_STR		""
#define DEF_FONT	"fixed"
#define DEF_PIXEL	"black"
#define DEF_STYLE	"1"
#define DEF_BOOL	"false"
#define DEF_DBL		"0.0"

#define DEF_MAX_FONT	1024
#define DEF_MAX_NAMES	10

#endif
